<?php

/**
 * Description of BaseObjLMB
 *
 * @author Damien CELLE, Thibault GRILLE, Florian MERCIER, Jonathan PERICHON
 */
class BaseobjLMB {

        /**
         * Serveur de connexion  la base de donnes de Lundi Matin Business
         */
        var $serverLMB = "localhost";

        /**
         * Identifiant de connexion  la base de donnes de Lundi Matin Business
         */
        var $loginLMB = "root";

        /**
         * Mot de passe de connexion  la base de donnes de Lundi Matin Business
         */
        var $passwordLMB = "";

        /**
         * Nom de la base de donnes de Lundi Matin Business
         */
        var $bddLMB = "lundi";

        /**
         * Tables de la base de donnes de Lundi Matin Business  modifier
         */
        var $tablesLMB;

        /**
         * Connexion au serveur mysql
         */
        var $linkLMB;

        /**
         * Constructeur
         */
        function BaseObjLMB() {
                $this->Cnx();
        }

        /**
         * Connexion  la base de Lundi Matin Business
         */
        function Cnx() {
                $this->linkLMB = @mysql_connect($this->serverLMB, $this->loginLMB, $this->passwordLMB);
                if(! $this->linkLMB && $_REQUEST['erreur'] != 1)
                        header("Location: maintenance.php?erreur=1");

                mysql_select_db($this->bddLMB, $this->linkLMB);

        }

        /**
         * Permet d'insrer un objet Thelia dans les tables concernes du ct de Lundi Matin Business
         */
        function addToLMB() {
			$this->cnx();
                foreach ($this->tablesLMB as $table) {
                        $repeat = 'repeat' . ucfirst($table);
                        if ($this->$repeat != null && $this->$repeat > 0) {
                                $i = 1;
                                while ($i <= $this->$repeat) {
                                        $nomComplet = $table . $i;
                                        $query = "insert into $table(" . $this->getListVarsSql($table) . ") values(" . $this->getListValsSql($nomComplet) . ")";
                                        $resul = mysql_query($query, $this->linkLMB);
                                        $i++;
                                }
                        }
                        else {
                                $query = "insert into $table(" . $this->getListVarsSql($table) . ") values(" . $this->getListValsSql($table) . ")";
                                $resul = mysql_query($query, $this->linkLMB);
                        }
                }
        }

        /**
         * Permet de mettre en forme un objet Thelia pour l'adapter au codage du ct de Lundi Matin Business
         */
        function miseEnForme() {
			$this->cnx();
                foreach ($this->tablesLMB as $table) {
                        $repeat = 'repeat' . ucfirst($table);
                        if ($this->$repeat != null && $this->$repeat > 0) {
                                $i = 1;
                                while ($i <= $this->$repeat) {
                                        if ($table == "docs_lines" || $table == "doc_lines_cdc") {
                                                $complet = 'miseEnForme' . ucfirst($table);
                                                $this->$complet($i);
                                                $i++;
                                        }
                                        else {
                                                $complet = 'miseEnForme' . ucfirst($table) . $i;
                                                $this->$complet();
                                                $i++;
                                        }
                                }
                        }
                        else {
                                $table = 'miseEnForme' . ucfirst($table);
                                $this->$table();
                        }
                }
        }

        /**
         * Permet d'obtenir la liste des champs de la table passe en paramtre
         * @param $table Table dans laquelle il faut insrer
         * @return Liste des champs de la table passe en paramtre spare par des virgules
         */
        function getListVarsSql($table) {
                $listvars="";
                $vars = 'bddvars' . ucfirst($table);

                for($i=0; $i<count($this->{$vars}); $i++) {
                        $listvars .= $this->{$vars}[$i] . ",";
                }

                return substr($listvars, 0, strlen($listvars)-1);
        }

        /**
         * Permet d'obtenir la liste des valeurs  insrer dans la table passe en paramtre
         * @param $table Table dans laquelle il faut insrer
         * @return Liste des valeurs entre guillemets  insrer dans la table passe en paramtre spare par des virgules
         */
        function getListValsSql($table) {
				$this->cnx();
                $listvals="";
                $vals = 'bddvals' . ucfirst($table);

                for($i=0; $i<count($this->{$vals}); $i++) {
                        $tempvar = $this->{$vals}[$i];

                        if(get_magic_quotes_gpc())
                                $tempvar = stripslashes($tempvar);

                        $tempvar = mysql_real_escape_string($tempvar, $this->linkLMB);

                        $listvals .= "\"" . $tempvar . "\",";
                }
                return substr($listvals, 0, strlen($listvals)-1);
        }

        /**
         * Permet d'insrer une chane dans une autre  partir d'une position donne
         * @param $insertstring Chane  insrer
         * @param $intostring Chane de destination
         * @param $offset Position d'insertion
         * @return La nouvelle chane
         */
        function str_insert($insertstring, $intostring, $offset) {
                $part1 = substr($intostring, 0, $offset);
                $part2 = substr($intostring, $offset);

                $part1 = $part1 . $insertstring;
                $whole = $part1 . $part2;
                return $whole;
        }

        /**
         * Fonction qui permet de construire un identifiant sous la forme ex. : C-000000-00001, C-050140-08011
         * @param $chaine Chane au dbut de l'id crer
         * @param $id Numro
         * @return L'id cre
         */
        function transform1lettersId($chaine, $id) {
                $long_id = strlen($id);
                $newId = '';
                $newId= str_pad($newId, 11-$long_id, '0', STR_PAD_LEFT);
                $newId = $chaine . $newId;
                $newId = $newId . $id;
                $newId = $this->str_insert('-', $newId, 1);
                $newId= $this->str_insert('-', $newId, 8);
                return $newId;
        }

        /**
         * Fonction qui permet de construire un identifiant sous la forme ex.: ADR-000000-00008
         * @param $chaine Chane au dbut de l'id crer
         * @param $id Numro
         * @return L'id cre
         */
        function transform3lettersId($chaine, $id) {
                $long_id = strlen($id);
                $newId = '';
                $newId= str_pad($newId, 11-$long_id, '0', STR_PAD_LEFT);
                $newId = $chaine . $newId;
                $newId = $newId . $id;
                $newId = $this->str_insert('-', $newId, 3);
                $newId= $this->str_insert('-', $newId, 10);
                return $newId;
        }

        /**
         * Fonction qui permet de construire un identifiant sous la forme ex.: DCE-000000-0184
         * @param $chaine Chane au dbut de l'id crer
         * @param $id Numro
         * @return L'id cre
         */
        function transformDocumentsEventsId($chaine, $id) {
                $long_id = strlen($id);
                $newId = '';
                $newId= str_pad($newId, 10-$long_id, '0', STR_PAD_LEFT);
                $newId = $chaine . $newId;
                $newId = $newId . $id;
                $newId = $this->str_insert('-', $newId, 3);
                $newId= $this->str_insert('-', $newId, 10);
                return $newId;
        }
}

?>
